<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): The Single-Source Shortest Path (SSSP) Algorithm</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">The Single-Source Shortest Path (SSSP) Algorithm<div class="ingroups"><a class="el" href="group__appGroup.html">Examples</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>The application for demonstrating the Single-Source Shortest Path (SSSP) algorithm using <a class="el" href="classTIGL.html" title="Top level class for the TIGL engine  . ">TIGL</a>.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSSSPInfo.html">SSSPInfo</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Defines the algorithm data field of the customized vertex class of the SSSP algorithm.  <a href="classSSSPInfo.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSSSPVertex.html">SSSPVertex&lt; DataType, EdgeType &gt;</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Customized <a class="el" href="classTIGLApiVertex.html" title="Core vertex class for the TIGL Engine (with only output edge buffer). ">TIGLApiVertex</a> class for the Single Source Shortest Path using the Dijkstra Algorithm.  <a href="classSSSPVertex.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSSSPCombiner.html">SSSPCombiner</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Combiner class for the SSSP algorithm.  <a href="classSSSPCombiner.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structSSSPNodeSeq.html">SSSPNodeSeq&lt; DIST_TYPE, ID_TYPE &gt;</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">A structure that contains algorithm data for Dijkstra vertex.  <a href="structSSSPNodeSeq.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSSSPVertexSeq.html">SSSPVertexSeq&lt; DataType, EdgeType, IdType &gt;</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vertex class for the sequential implementation of the SSSP algorithm.  <a href="classSSSPVertexSeq.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:gaf90824509586333cf45ce757d2711ce3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gaf90824509586333cf45ce757d2711ce3"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__SSSP.html#gaf90824509586333cf45ce757d2711ce3">COLOR</a> </td></tr>
<tr class="memdesc:gaf90824509586333cf45ce757d2711ce3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Possible colors of the vertices during the algorithm execution. <br /></td></tr>
<tr class="separator:gaf90824509586333cf45ce757d2711ce3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga0ddf1224851353fc92bfbff6f499fa97"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__SSSP.html#ga0ddf1224851353fc92bfbff6f499fa97">main</a> (int argc, char *argv[])</td></tr>
<tr class="memdesc:ga0ddf1224851353fc92bfbff6f499fa97"><td class="mdescLeft">&#160;</td><td class="mdescRight">The <a class="el" href="group__SSSP.html#ga0ddf1224851353fc92bfbff6f499fa97" title="The main() function of the SSSP application. ">main()</a> function of the SSSP application.  <a href="#ga0ddf1224851353fc92bfbff6f499fa97">More...</a><br /></td></tr>
<tr class="separator:ga0ddf1224851353fc92bfbff6f499fa97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1159898932867e0fe29945833a109885"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:ga1159898932867e0fe29945833a109885"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__SSSP.html#ga1159898932867e0fe29945833a109885">dijkstra</a> (vector&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt; &amp;vertexList, typename CVertex::ID_TYPE src)</td></tr>
<tr class="memdesc:ga1159898932867e0fe29945833a109885"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sequential implementation of the single-source shortest path algorithm.  <a href="#ga1159898932867e0fe29945833a109885">More...</a><br /></td></tr>
<tr class="separator:ga1159898932867e0fe29945833a109885"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>The application for demonstrating the Single-Source Shortest Path (SSSP) algorithm using <a class="el" href="classTIGL.html" title="Top level class for the TIGL engine  . ">TIGL</a>. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga1159898932867e0fe29945833a109885"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void dijkstra </td>
          <td>(</td>
          <td class="paramtype">vector&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>vertexList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename CVertex::ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sequential implementation of the single-source shortest path algorithm. </p>
<p>This is a template function that runs the SSSP algorithm on an adjacency list of vertices. The output of the PageRank algorithm is stored in the algData field of each vertex </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexList</td><td>a vector that contains the adjacency list. The input vertices must be of type <a class="el" href="classSSSPVertexSeq.html" title="Vertex class for the sequential implementation of the SSSP algorithm. ">SSSPVertexSeq</a> </td></tr>
    <tr><td class="paramname">src</td><td>the ID of the source vertex </td></tr>
  </table>
  </dd>
</dl>
<p>body</p><ol type="1">
<li>initializing all vertices</li>
<li>push the source vertex to the active queue</li>
<li>Pop all vertices from active list and update their children</li>
<li>continue until the active queue becomes empty </li>
</ol>

</div>
</div>
<a class="anchor" id="ga0ddf1224851353fc92bfbff6f499fa97"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int main </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>argc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>argv</em>[]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The <a class="el" href="group__SSSP.html#ga0ddf1224851353fc92bfbff6f499fa97" title="The main() function of the SSSP application. ">main()</a> function of the SSSP application. </p>
<p>Runs the Single-Source Shortest Path (SSSP) algorithm on a graph and stores the distance and parent of each vertex in the algorithm data field </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">argc</td><td>Argument count </td></tr>
    <tr><td class="paramname">argv</td><td>Argument vector </td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd><b>usage:</b> &lt;outFileName&gt; &lt;numVerteices&gt; &lt;avNumEdges&gt; </dd></dl>
<dl class="section return"><dt>Returns</dt><dd>Status </dd></dl>
<p>body</p>
<ol type="1">
<li>MPI initialization (only in case of multiple devices)</li>
<li>Reading Graph Parameters</li>
<li>Initializing the TIGL engine with proper vertex definition for the SSSP algorithm</li>
<li>Reading the Graph file</li>
<li>running the TIGL engine to execute the SSSP algorithm on the graph</li>
<li>Printing profiling information</li>
<li>(optional) Running the reference sequential implementation of the page rank algorithm</li>
<li>(optional) Comparing the output results with the reference implementation </li>
</ol>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
